from owg.util.opengl import ColorF
from mini.bossmulti.placeable import Thundercloud

from java.lang import Float

bogus = world["Bogus"]

settings = game.getSettings()

top_start = settings.backgroundColor.get()
bottom_start = settings.backgroundBottomColor.get()

top_goal = ColorF("#717C7C")
bottom_goal = ColorF("#565962")

thunderclouds = world_objects(Thundercloud)

state = SimpleNamespace()
state.max_unit = 0

def step():
	unit = bogus.getX() / 600
	state.max_unit = max(unit, state.max_unit)
	
	bogus.speedScalar = max(0.5, min(1, 1.3 - unit))
	
	color_unit = max(0, min(1, state.max_unit - 0.2))
	top = top_start.deriveMix(top_goal, color_unit)
	bottom = bottom_start.deriveMix(bottom_goal, color_unit)
	
	settings.backgroundColor.set(top)
	settings.backgroundBottomColor.set(bottom)
	
	target_intensity = max(0, min(state.max_unit, 1))
	
	for cloud in thunderclouds:
		intensity = cloud.maxIntensity.get()
		if (intensity < target_intensity):
			cloud.maxIntensity.set(Float(intensity + 0.01))