import random

from audio import Audio

from owg.util.euclidian.Compass import *
from owg.util.euclidian import V2F
from mini.bossmulti import Stench
from java.lang import System

from owg.util import Calc

from hubol.entity import AdvancedDecal

from bogus.core.BogusCore import egl

state = SimpleNamespace()
state.splashing = False
state.splash_prog = 0

borgus = world["Borgus"]

tub = world["Tub"]
shove = V2F(16, 0)
gravity = V2F(0, 18)

state.parallax = 0

camera = game.camera

splashes = [decal for decal in world_objects(AdvancedDecal) if decal.texture.get() == "splash"]

def stink(alarm):
	if (borgus.isVisible()):
		len = random.uniform(-80, 80)
		dir = borgus.state.angle - Calc.PI/2
		pos = borgus.state.pos.clone().add(Calc.fastDirX(len, dir), Calc.fastDirY(len, dir))
		stench = Stench(list, pos, 2.25, random.uniform(0.075, 0.1))
		stench.state.progress = 0.5
		alarm.restart(random.randint(2, 4))

def show_clean_borgus():
	world["AllCleanNow"].show_borgus()
		
def step():
	if state.splashing:
		state.splash_prog += 0.175
		if state.splash_prog >= 3:
			state.splashing = False
		
		for splash in splashes:
			if state.splashing:
				splash.setVisible(True)
				splash.state.scale.multiply(0.99, 0.975)
				splash.imageIndex = int(state.splash_prog)
			else:
				splash.setVisible(False)
		
	dest_pos = tub.pos.y()
		
	if (borgus.getY() >= dest_pos):
		borgus.setVisible(False)
		return
	
	if (borgus.getY() >= dest_pos - 80 and not state.splashing):
		state.splashing = True
		alarm(show_clean_borgus).start(30)
		Audio.play("borgus splash", None, 1, None, 1)
	
	cam_pos = game.camera.pos
	
	state.parallax -= 5.75
	world["para_Building1"].state.pos.y(cam_pos.y() + state.parallax * 0.92 + 526 * 2)
	world["para_Building2"].state.pos.y(cam_pos.y() + state.parallax * .95 + 486 * 2)
	
	borgus.state.angle -= gravity.y() * 0.002
	borgus.state.pos.add(gravity)
	borgus.state.pos.add(shove)
	shove.accelerateTowards(V2F.ZERO, 1)
	gravity.add(0, 0.3)
	
	cam_pos.set(game.camera.pos.x(), borgus.state.pos.y() - 243)
	
def start():
	tub.texture.setRepeating(egl, False, False)
	alarm_restartable(stink).start(1)
	for splash in splashes:
		splash.setVisible(False)