from mini.bossmulti.Minimanager.Speaker import *

from mini.bossmulti.Minimanager import Action
from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager import MessageState

from mini.bossmulti.Borgus.Event import *

from mini.bossmulti import Death

from audio import Audio

from owg.util import Calc

state = SimpleNamespace()
state.borgus = None
state.conedTimes = 0

state.lastOuchedDistance = 0
state.maximumDistance = 0

state.scolds = 0
state.rush_him = False

def can_tell_rush_him():
	return not state.rush_him and state.conedTimes > 25 and state.maximumDistance < 100

def coned(borgus):
	state.conedTimes += 1
	if (state.conedTimes == 1):
		mini.setConversation(Message(BORGUS, "Yowch!"))
	elif (can_tell_rush_him()):
		state.rush_him = True
		mini.setConversation(
			Message(DRUMMER, "((Psst Bogus! You need to rush him!))"), Delay(90),
			Message(DRUMMER, "((Run toward's him and fire cones!))"), Delay(90),
			Message(BOGUS, "((Got it--thanks))")
		)
	elif (state.conedTimes % 5 == 0 and state.lastOuchedDistance < state.maximumDistance):
		state.lastOuchedDistance = state.maximumDistance
		if (can_tell_rush_him()):
			mini.message(BORGUS, Calc.choose("Ow!", "Ouch!", "Oof!!", "Oomph!", "Oshit!", "Ahh!"))
		else:
			mini.setConversation(
				Message(BORGUS, Calc.choose("Ow!", "Ouch!", "Oof!!", "Oomph!", "Oshit!", "Ahh!")),
				Delay(45),
				Action(scold)
			)

def scold1():
	mini.setConversation(
		Message(BORGUS, "These cone's are unusually sharp!"), Delay(90),
		Message(BORGUS, "Perhaps my Worm armada could utilize these!!!"), Delay(90),
		Message(BORGUS, "Wear did you find such sharp cones?"), Delay(90),
		
		Message(DRUMMER, "Eh mostly around town, etc"), Delay(90),
		Message(DRUMMER, "Theres some here tho :-P\nhttps://www.cone-zone.com/Work-Area-Protection-18PVCS-Fluorescent/dp/B07FN11XLL/ref=sr_1_fkmr2_3?ie=UTF8&qid=1547693384&sr=8-3-fkmr2&keywords=pointy+traffic+cone"),
		Delay(90),
		
		Message(BORGUS, "Thanks--ordered."), Delay(60)
	)
	
def scold2():
	mini.setConversation(
		Message(BORGUS, "Those cone's can really push a guy around!")
	)
		
def scold():
	state.scolds += 1
	if (state.scolds == 1):
		scold1()
	elif (state.scolds == 2):
		scold2()

def clear_weather():
	world["Weather"].on_battle_end()
		
def died(borgus):
	Audio.stopMusic(0)
	game.getSettings().levelActive.set(False)
	mini.setConversation(
		Message(BORGUS, "X_X")
	)
	alarm( lambda : reward(borgus)).start(120)
	alarm(clear_weather).start(60)
	
def reward(borgus):
	prize = world["PrizeRight"] if borgus.state.pos.x() < 432 else world["PrizeLeft"]
	world["PrizeController"].call("activate_prize", prize)
	
def step():
	if (not state.borgus is None):
		state.maximumDistance = max(state.borgus.state.pos.x() - state.borgus.start.x(), state.maximumDistance)

def filter_event(borgus, event):
	if (not borgus.dead and event == CONED):
		coned(borgus)
	elif (event == DIED):
		died(borgus)

def begin_listening(borgus):
	state.borgus = borgus
	borgus.events.addListener(filter_event)