from owg.util.euclidian import V2D
from owg.util import Calc
from java.lang import Math

from mini.bossmulti.placeable.Prize.Event import *

from audio import Audio

tone = Audio.getClip("tone loop")

state = SimpleNamespace()
state.prize = None
state.prize_target_pos = None
state.gravity = 6

state.pitch = 5
state.gain = 0

state.target_pitch = 1.5
state.target_gain = 0.625

def stop_tone():
	tone.setLooping(False)
	tone.stop()

def destroy():
	stop_tone()

def step():
	prize = state.prize
	if (prize is None or prize.isDestroyed()):
		return
	if (prize.state.pos.equals(state.prize_target_pos)):
		state.target_pitch = 1
		state.target_gain = 0
	elif (not prize.prev.pushed):
		prize.state.pos.accelerateTowards(state.prize_target_pos, state.gravity)
		prize.moved()
		state.gravity += 1.1
		
	state.gain = Calc.approachLin(state.gain, state.target_gain, 0.03)
	state.pitch = Calc.approachLin(state.pitch, state.target_pitch, 0.2)
	tone.setPosition(None, state.gain)
	tone.setSpeed(None, state.pitch)

def activate_prize(prize):
	tone.setPosition(None, 0)
	tone.setLooping(True)
	tone.play()
	state.prize = prize
	state.prize_target_pos = prize.state.pos.clone().add(0, 7 * 32)
	
def collected(prize):
	stop_tone()
	
def filter_prize_event(prize, event):
	if (event == COLLECTED):
		collected(prize)