from mini.bossmulti.Minimanager.Speaker import *
from mini.bossmulti.Minimanager import Message
from mini.bossmulti.Minimanager import Delay
from mini.bossmulti.Minimanager import Transmit
from mini.bossmulti.Minimanager.MessageState import *

from mini.bossmulti import ConeProjectile
from owg.util.euclidian import V2F

from audio import Audio

from hubol.util import AsdEnvelope
from hubol.util.AsdEnvelope.UnitFunction import *
from hubol.util.AsdEnvelope import ElasticFunction

from mini.bossmulti import Death

state = SimpleNamespace()

ease_out = ElasticFunction(LINEAR, 3, 0.7)
miracle_envelope = AsdEnvelope(0, INV_EXPONENTIAL, 0.15, 1.2, 0.0, 1, ease_out, 0.4)

class MiracleProjectile(ConeProjectile):
	def __init__(self, list, owner, pos, speed):
		ConeProjectile.__init__(self, list, owner, pos, speed)
		Audio.play("miracle", None, 1.0, None, 1.0)
		self.renderScale = 0
		self.my_prog = 0

	def step(self):
		if self.my_prog < 1:
			self.my_prog += 0.02
			self.renderScale = miracle_envelope.value(self.my_prog)
		else:
			ConeProjectile.step(self)

def miracle():
	MiracleProjectile(list, None, this.state.pos.asV2F(), V2F(-7, 0))

spare_cone = Message(DRUMMER, "...I've kept a spare cone for exactly this reason!")
	
def delay_minigame():
	if Death.getCurrentMapDeaths(editor) == 0:
		mini.setConversation(
			Transmit(45), Message(DRUMMER, "Sup baby? You stuck againb?"),
			Delay(60), Message(BOGUS, "Yemp.. stuck like a buck...."),
			Transmit(60), Message(DRUMMER, "I see"),
			Delay(60), Message(DRUMMER, "Well... Theres a bit of promblem."),
			Delay(60), Message(DRUMMER, "There's no construction on this side of town!"),
			Delay(60), Message(DRUMMER, "(aka no cones!)"),
			Delay(60), Message(BOGUS, "Dude for real?!"),
			Delay(60), Message(BOGUS, "That really throw's a wrench in our plans!"),
			Delay(60), Message(BOGUS, "Thats raining all over my parade!"),
			Transmit(60), Message(DRUMMER, "I know, I know."),
			Delay(60), Message(DRUMMER, "Just caln down--be lit."),
			Delay(60), spare_cone,
			Delay(90), Message(BOGUS, "I love youre cone miracles!!!")
		)
	else:
		mini.setConversation(
			Transmit(15), Message(DRUMMER, "Just calm down--be lit."),
			Delay(60), spare_cone,
			Delay(90), Message(BOGUS, "I love youre awesome cone miracles!!!")
		)
			
def start():
	world["Mirror"].destroyOnOverboost = False
	world["Mirror2"].destroyOnOverboost = False
	
	alarm(delay_minigame).start(1)

def step():
	if spare_cone.state == SENT and not hasattr(state, "miracle_performed"):
		state.miracle_performed = None
		alarm(miracle).start(60)
		