from mini.bossmulti.placeable import Thundercloud
from owg.util import Calc
from owg.util.opengl import ColorF

from java.lang import Float

settings = game.getSettings()

top_start = settings.backgroundColor.get()
bottom_start = settings.backgroundBottomColor.get()

top_goal = ColorF("#96E1FF")
bottom_goal = ColorF("#3497E2")

state = SimpleNamespace()
state.battle_started = False
state.battle_ended = False

state.beautiful_sky = 0

thunderclouds = world_objects(Thundercloud)

def step():
	intensity_target = 0.5

	if (state.battle_ended):
		intensity_target = 0
		for cloud in thunderclouds:
			cloud.state.pos.add(-3 if cloud.getX() < 432 else 3, 0)
		
		state.beautiful_sky = Calc.approachLin(state.beautiful_sky, 1, .01)
		color_unit = state.beautiful_sky
			
		top = top_start.deriveMix(top_goal, color_unit)
		bottom = bottom_start.deriveMix(bottom_goal, color_unit)
		
		settings.backgroundColor.set(top)
		settings.backgroundBottomColor.set(bottom)	
		
	elif (state.battle_started):
		intensity_target = 0.1
	
	for cloud in thunderclouds:
		intensity = cloud.maxIntensity.get()
		
		# cloud.maxIntensity.set(Float(intensity + 0.01))
		new_intensity = Float(Calc.approachLin(intensity, intensity_target, 0.01))
		cloud.maxIntensity.set(new_intensity)

def on_battle_start():
	state.battle_started = True
	
def on_battle_end():
	state.battle_ended = True